
; IP-LOCATOR, par Averell (fonction /whereis)
;
; But du snippet: retrouver les coordonnées géographiques d'un pseudo à partir de son ip: Pays, Ville, Région et FAI
;
; Taper /whereis pseudo pour avoir les infos du pseudo. Possibilité de l'utiliser dans la nicklist
;
; Pour info, le script s'aide du site ip-adress.com en simulant une connexion web. Le texte téléchargé est ensuite traité à l'aide de regexps.
; ATTENTION: ip-addr.com a mis un quota dépendant de votre adresse ip propre: il ne fonctionnera que 50 fois dans une journée.
;
; Ne fonctionne *que* sur les serveurs dinosauriens qui révèlent les ip (par exemple undernet, à la condition que le pseudo n'utilise pas son host enregistré)
; Ce code peut interférer avec un script utilisant déjà la fonction /dns, qui permet comme chacun sait de retrouver l'adresse ip d'un pseudo, ou le host d'une ip.
;
; Copyright: vous pouvez copier ce code, le modifier, l'incorporer dans votre script, le vendre si vous voulez! Ca m'étonnerait que ce truc vous rende riche... Mais sait-on jamais!
;
; Merci à Vestax, qui a disparu de la circulation, à qui j'ai emprunté un bout de code.

alias whereis {  
  %whereis.nick = $1 | %whereis.ipaddr = $2 | sockopen ipaddr www.localiser-ip.com 80
}

on *:sockopen:ipaddr:{ 
  sockwrite -n ipaddr GET http://www.localiser-ip.com/?ip= $+ %whereis.ipaddr
}

on *:sockread:ipaddr:{
  if ($sockerr > 0) return
  unset %whereis.x
  echo 12 -a -
  set %whereis.regexp /^([^(]+)\(([^-]+)- ([^)]*)/
  unset %whereis.ville
  unset %whereis.pays
  unset %whereis.region

  :nextread
  sockread %temp 

  if ($sockbr == 0) { echo 12 -a - | return }
  if ($regex(R,%temp,/utilisateur de l'adresse IP/) > 0) { 

    if ($regex(R1,%temp,/<b>([^<]+)<\/b>[^<]+<b>([^<]+)<\/b>/) > 0) { set %whereis.fai $regml(R1,1) | set %whereis.x $regml(R1,2) }
    if ($regex(R2,%whereis.x,%whereis.regexp) > 0) { 
      set %whereis.ville $regml(R2,1) | set %whereis.pays $regml(R2,2) | set %whereis.region $regml(R2,3)

    }

    if (%whereis.pays != $null) {
      echo 12 -a Pays de %whereis.nick : %whereis.pays
      echo 12 -a Region de %whereis.nick : %whereis.region
      echo 12 -a Ville de %whereis.nick : %whereis.ville
      echo 12 -a FAI de %whereis.nick : %whereis.fai
    }
  }

  goto nextread
}
